document.onreadystatechange = function () {
  if (document.readyState === 'interactive') renderApp();

  function renderApp() {
    var onInit = app.initialized();
    onInit
      .then(function getClient(_client) {
        window.client = _client;
        client.events.on('app.activated', renderReplyInEditor);
      })
      .catch(handleErr);
  }
};

function renderReplyInEditor() {

  client.data.get("ticket").then((ticketDetail) => {
    client.data.get("domainName").then((domainDetail) => {
      let ticket_conversations = getConversations(domainDetail.domainName, ticketDetail.ticket.id, 1, []);
      Promise.all([ticket_conversations]).then(function (data) {
        let conversations = data[0];
        console.log(conversations);

        let user_conversations = conversations.filter(converstation => (converstation.private === false));
        let conIdx = user_conversations.length - 1;
        if (user_conversations.length > 3) {
          client.interface.trigger("click", { id: "deleteQuotedText" })
            .then(function () {

              conIdx = user_conversations.length - 1;
              body_text = ``;
              for (let i = conIdx; i > 0; i--) {
                body_text += user_conversations[i].body;
              }
              client.interface.trigger("setValue", { id: "editor", text: body_text, replace: true });
            }).catch(handleErr);
        }
              
      }).catch(handleErr);
    }, error => {
      handleErr(error)
    });
  }, error => {
    handleErr(error)
  });
}

function getConversations(domainName, ticketId, page, conversations) {
  const dataUrl = `https://${domainName}/api/v2/tickets/${ticketId}/conversations`;
  const options = { headers: { "Authorization": "Basic <%= encode(iparam.apiKey) %>" } };
  return new Promise(function (resolve, reject) {
    client.request.get(dataUrl, options).then(function (data) {
      let response = JSON.parse(data.response);
      conversations = conversations.concat(response);
      page++;
      if (response.length != 0) {
        getConversations(page, conversations).then(function (data) {
          resolve(data);
        }, function () {
          resolve(conversations);
        });
      } else {
        resolve(conversations);
      }
    }).catch(function (err) {
      reject(err);
    });
  });
}

function handleErr(err = 'None') {
  console.error(`Error occured. Details:`, err);
}
